import com.gct.dataengine.register.DataEngineRegisterApplication;
import com.gct.dataengine.register.entity.Collector;
import com.gct.dataengine.register.entity.CollectorTaskInfoVo;
import com.gct.dataengine.register.service.impl.CollectorTaskManage;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.quartz.Scheduler;
import org.quartz.SchedulerException;
import org.quartz.SchedulerFactory;
import org.quartz.impl.StdSchedulerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.util.Map;
import java.util.Objects;
import java.util.Random;

/**
 * @author xusirui 2022/4/8
 */
@Slf4j
@SpringBootTest(classes = DataEngineRegisterApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class RedisTest {

    @Autowired
    CollectorTaskManage deviceManageService;

    @Autowired
    RedisTemplate<String, Object> redisTemplate;

    @Test
    public void test1() throws IOException {
        System.out.println(deviceManageService.pullCollectorTaskInfo());
    }

    @FunctionalInterface
    public interface myFunction {
        void method();
    }

    public void asyncCircleDo(myFunction x, Integer times) {
        new Thread(() -> {
            Integer T = times;
            while (T-- > 0) {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                x.method();
            }
        }).start();
    }

    @Test
    public void pushTask(){
        deviceManageService.pushTask("template.xml","1");
    }

    @Test
    public void removeTask() {
        deviceManageService.removeTask("template.xml");
    }

    @Test
    public void breathTest() throws InterruptedException {
//        deviceManageService.unbind();
        deviceManageService.unbind();
        deviceManageService.pushTask("111","1");
        deviceManageService.pushTask("222","1");
        deviceManageService.pushTask("333","1");
        deviceManageService.pushTask("444","1");
        deviceManageService.pushTask("555","1");
        deviceManageService.pushTask("666","1");
        deviceManageService.pushTask("777","1");
        deviceManageService.pushTask("888","1");
        deviceManageService.pushTask("999","1");
        Integer alive1 = 10;
        Integer alive2 = 25;
        asyncCircleDo(() -> deviceManageService.heartBeat(new Collector("1", "aa", "aa", 5, 10, 15, 10)), alive1);
        asyncCircleDo(() -> deviceManageService.heartBeat(new Collector("2", "bb", "bb", 7, 10, 20, 15)), alive2);
        asyncCircleDo(() -> {
            CollectorTaskInfoVo collectorTaskInfoVo = deviceManageService.pullCollectorTaskInfo();
            String res = balanceAlgo(collectorTaskInfoVo);
            if (Objects.nonNull(res)) {
                boolean r = deviceManageService.bind("1", res, collectorTaskInfoVo.getUuidVersion());
                System.out.println(Thread.currentThread().getName() + "---" + res + " " + r);
            }
        }, alive1);
        asyncCircleDo(() -> {
            CollectorTaskInfoVo collectorTaskInfoVo = deviceManageService.pullCollectorTaskInfo();
            String res = balanceAlgo(collectorTaskInfoVo);
            if (Objects.nonNull(res)) {
                boolean r = deviceManageService.bind("2", res, collectorTaskInfoVo.getUuidVersion());
                System.out.println(Thread.currentThread().getName() + "---" + res + " " + r);
            }
        }, alive2);
        asyncCircleDo(() -> System.out.println(deviceManageService.pullCollectorTaskInfo()), 100);
        Thread.sleep(1000 * 100);
    }

    public String balanceAlgo(CollectorTaskInfoVo collectorTaskInfoVo) {
        for (Map.Entry<Object, Object> entry : collectorTaskInfoVo.getTaskCollectorMap().entrySet()) {
            if (entry.getValue().equals("null")) return entry.getKey().toString();
        }
        return null;
    }


    @Test
    public void watchTest(){
        try{
            redisTemplate.watch("aaa");
            redisTemplate.multi();
            redisTemplate.opsForValue().set("wwwwe",4);
            redisTemplate.opsForValue().set("aaa",6);
            redisTemplate.opsForValue().set("asdad",4);
            redisTemplate.opsForValue().set("asfasf",4);
            System.out.println("begin");
            Thread.sleep(3000);
            System.out.println("end");
            System.out.println(redisTemplate.exec());
        }catch (Exception e){
            e.printStackTrace();
        }
    }


    @Test
    public void scheduleTest() throws SchedulerException {
        int T = 10;
        while (T-->0)
        System.out.println(new Random().nextInt());
    }
}
