package com.gct.dataengine.register.config;

import com.alibaba.fastjson.support.spring.FastJsonRedisSerializer;
import com.gct.dataengine.register.service.impl.CollectorTaskManage;
import com.sun.jmx.remote.internal.ArrayQueue;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanPostProcessor;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.*;
import org.springframework.data.redis.serializer.JdkSerializationRedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;

import java.util.Objects;
import java.util.Queue;
import java.util.UUID;

/**
 * @author xusirui 2022/4/8
 */
@Configuration
public class RedisConfig implements BeanPostProcessor {

    @Bean
    public RedisTemplate<String, Object> redisTemplate(RedisConnectionFactory redisConnectionFactory) {
        RedisTemplate<String, Object> redisTemplate = new RedisTemplate<>();
        redisTemplate.setKeySerializer(new StringRedisSerializer());
        redisTemplate.setHashKeySerializer(new StringRedisSerializer());
        redisTemplate.setHashValueSerializer(new FastJsonRedisSerializer<>(Object.class));
        redisTemplate.setValueSerializer(new FastJsonRedisSerializer<>(Object.class));
        redisTemplate.setConnectionFactory(redisConnectionFactory);
        redisTemplate.setEnableTransactionSupport(true);
        return redisTemplate;
    }

    @Override
    public Object postProcessAfterInitialization(Object bean, String beanName) throws BeansException {
        if (beanName.equals("redisTemplate")){
            RedisTemplate<String,Object> redisTemplate = (RedisTemplate<String,Object>) bean;
            if (Objects.isNull(redisTemplate.opsForValue().get(CollectorTaskManage.versionName))){
                redisTemplate.opsForValue().set(CollectorTaskManage.versionName, UUID.randomUUID());
            }
        }
        return BeanPostProcessor.super.postProcessAfterInitialization(bean, beanName);
    }

}


