package com.gct.dataengine.register.quartztask;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.dataengine.register.entity.TemplateTaskVo;
import com.gct.dataengine.register.feign.SuitcaseClient;
import com.gct.dataengine.register.service.impl.CollectorTaskManage;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * @author xusirui 2022/7/11
 */
public class PullTemplateTaskJob extends QuartzJobBean {

    @Autowired
    SuitcaseClient suitcaseClient;

    @Autowired
    CollectorTaskManage collectorTaskManage;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        String res = suitcaseClient.getEnabledTemplate();
        List<TemplateTaskVo> templateTasks = JSONObject.parseArray(JSONObject.parseObject(res, Result.class).getData().toString(), TemplateTaskVo.class);
        System.out.println(templateTasks);
        templateTasks.forEach(x->{
            collectorTaskManage.pushTask(x.getTaskId(),x.getVersion());
        });
        Set<String> templateTaskSet = templateTasks.stream().map(TemplateTaskVo::getTaskId).collect(Collectors.toSet());
        collectorTaskManage.getAllTask().forEach(taskId->{
            if (!templateTaskSet.contains(taskId)){
                collectorTaskManage.removeTask(taskId.toString());
                System.out.println("remove expire task "+taskId);
            }
        });
    }
}
